//
//  PTColorAlertView.m
//  Electachord
//
//  Created by Nick Kruge on 3/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ChordChangeAlertView.h"
#import "string.h"



@implementation ChordChangeAlertView

- (id)initWithFrame:(CGRect)frame {
	if (self = [super initWithFrame:frame]) {
		
		redLabel = [[UILabel alloc] initWithFrame:CGRectZero];
		redLabel.backgroundColor = [UIColor clearColor];
		redLabel.text = @"Root";
		redLabel.textColor = [UIColor whiteColor];
		redLabel.font = [UIFont fontWithName:@"STHeitiJ-Medium" size:20];
		redLabel.shadowColor = [UIColor blackColor];
		redLabel.shadowOffset = CGSizeMake(0, -1);
		
		greenLabel = [[UILabel alloc] initWithFrame:CGRectZero];
		greenLabel.backgroundColor = [UIColor clearColor];
		greenLabel.text = @"Quality";
		greenLabel.textColor = [UIColor whiteColor];
		greenLabel.font = [UIFont fontWithName:@"STHeitiJ-Medium" size:20];
		greenLabel.shadowColor = [UIColor blackColor];
		greenLabel.shadowOffset = CGSizeMake(0, -1);
		
		blueLabel = [[UILabel alloc] initWithFrame:CGRectZero];
		blueLabel.backgroundColor = [UIColor clearColor];
		blueLabel.text = @"Range";
		blueLabel.textColor = [UIColor whiteColor];
		blueLabel.font = [UIFont fontWithName:@"STHeitiJ-Medium" size:20];
		blueLabel.shadowColor = [UIColor blackColor];
		blueLabel.shadowOffset = CGSizeMake(0, -1);
		
		chordLabel = [[UILabel alloc] initWithFrame:CGRectZero];
		chordLabel.backgroundColor = [UIColor clearColor];
		chordLabel.text = @"Change...";
		chordLabel.textColor = [UIColor whiteColor];
		chordLabel.font = [UIFont fontWithName:@"STHeitiJ-Medium" size:30];
		chordLabel.shadowColor = [UIColor blackColor];
		chordLabel.shadowOffset = CGSizeMake(0, -3);
		
		redSlider = [[UISlider alloc] initWithFrame:CGRectZero];
		[redSlider addTarget:self action:@selector(redSliderValueChanged:) forControlEvents:UIControlEventValueChanged];
		
		greenSlider = [[UISlider alloc] initWithFrame:CGRectZero];
		[greenSlider addTarget:self action:@selector(greenSliderValueChanged:) forControlEvents:UIControlEventValueChanged];
		
		//blueSlider = [[UISlider alloc] initWithFrame:CGRectZero];
		//[blueSlider addTarget:self action:@selector(blueSliderValueChanged:) forControlEvents:UIControlEventValueChanged];
		
		[redSlider setValue:0.0 animated:YES];
		[greenSlider setValue:0.6 animated:YES];
		//[blueSlider setValue:0.5 animated:YES];
		
		[self addSubview:redLabel];
		[self addSubview:greenLabel];
		//[self addSubview:blueLabel];
		[self addSubview:redSlider];
		[self addSubview:greenSlider];
		//[self addSubview:blueSlider];
		[self addSubview:chordLabel];
		//[self addSubview:previewView]; 
	}
	
	rootName = new char[5];
	chordQuality = new char[4];
	
	rootName = "ROOT";
	chordQuality = "QUAL";
	chord = [[NSString alloc] initWithFormat: @"%s %s", rootName, chordQuality];
	
	return self;
}

- (void)redSliderValueChanged:(UISlider *)slider {
	//[UIView beginAnimations:nil context:NULL];
	keynumber = floor(slider.value * 12) + 1;
	
	
	switch(keynumber) {
		case 1: rootName = "A";
			chordLabel.center = CGPointMake(480/2-8, 320*.65);
			
			break;
		case 2: rootName = "A#/Bb";
			chordLabel.center = CGPointMake(480/2-46, 320*.65);
			break;
		case 3: rootName = "B";
			chordLabel.center = CGPointMake(480/2-8, 320*.65);
			break;
		case 4: rootName = "C";
			chordLabel.center = CGPointMake(480/2-8, 320*.65);
			break;
		case 5: rootName = "C#/Db";
			chordLabel.center = CGPointMake(480/2-46, 320*.65);
			break;
		case 6: rootName ="D";
			chordLabel.center = CGPointMake(480/2-8, 320*.65);
			break;
		case 7: rootName = "D#/Eb";
			chordLabel.center = CGPointMake(480/2-46, 320*.65);
			break;
		case 8: rootName = "E";
			chordLabel.center = CGPointMake(480/2-8, 320*.65);
			break;
		case 9: rootName = "F";
			chordLabel.center = CGPointMake(480/2-8, 320*.65);
			break;
		case 10: rootName = "F#/Gb";
			chordLabel.center = CGPointMake(480/2-46, 320*.65);
			break;
		case 11: rootName = "G";
			chordLabel.center = CGPointMake(480/2-8, 320*.65);
			break;
		case 12: rootName = "G#/Ab";
			chordLabel.center = CGPointMake(480/2-46, 320*.65);
			break;
			
	}
	chord = [[NSString alloc] initWithFormat: @"%s %s", rootName, chordQuality];
	chordLabel.text = chord;
	
	NSDictionary * dict = [NSDictionary dictionaryWithObjectsAndKeys: 
						   greenSlider, @"key1", redSlider, @"key2", chord, @"key5", nil]; 
	
	
	[[NSNotificationCenter defaultCenter] postNotificationName:@"changeChord" object:self userInfo: dict]; 
	
	//[UIView commitAnimations];
}


- (void)greenSliderValueChanged:(UISlider *)slider {
	//[UIView beginAnimations:nil context:NULL];
	//previewView.backgroundColor = [UIColor colorWithRed:redSlider.value green:slider.value blue:blueSlider.value alpha:1.0];
	qualnumber = floor(slider.value * 7);
	switch(qualnumber) {
		case 1: chordQuality = "dim";
			break;
		case 2: chordQuality = "min";
			break;
		case 3: chordQuality = "min7";
			break;
		case 4: chordQuality = "maj";
			break;
		case 5: chordQuality = "maj7";
			break;
		case 6: chordQuality = "maj9";
			break;
		case 7: chordQuality = "aug";
			break;
	}
	
	chord = [[NSString alloc] initWithFormat: @"%s %s", rootName, chordQuality];
	chordLabel.text = chord;
	NSDictionary * dict = [NSDictionary dictionaryWithObjectsAndKeys: 
						   greenSlider, @"key1", redSlider, @"key2", chord, @"key5", nil]; 
	
	
	[[NSNotificationCenter defaultCenter] postNotificationName:@"changeChord" object:self userInfo: dict]; 
	//[UIView commitAnimations];
}


//- (void)blueSliderValueChanged:(UISlider *)slider {
//	[UIView beginAnimations:nil context:NULL];
//	previewView.backgroundColor = [UIColor colorWithRed:redSlider.value green:greenSlider.value blue:slider.value alpha:1.0];
//	[UIView commitAnimations];
//}



- (void)setFrame:(CGRect)rect {
	[super setFrame:CGRectMake(0, 0, rect.size.width, 300)];
	self.center = CGPointMake(480/2, 320/2);
}

- (void)layoutSubviews {
	CGFloat buttonTop;
	for (UIView *view in self.subviews) {
		if ([[[view class] description] isEqualToString:@"UIThreePartButton"]) {
			view.frame = CGRectMake(view.frame.origin.x, self.bounds.size.height - view.frame.size.height - 15, view.frame.size.width, view.frame.size.height);
			buttonTop = view.frame.origin.y;
		}
	}
	buttonTop -= 7; buttonTop -= 80;
	chordLabel.frame = CGRectMake(self.frame.size.width/2 - 100, buttonTop, self.frame.size.width - 53, 100);
	
	buttonTop -= 7; buttonTop -= 15;
	
	greenSlider.frame = CGRectMake(46, buttonTop, self.frame.size.width - 52 - 65, 30);
	buttonTop -= 22;
	greenLabel.frame = CGRectMake(self.frame.size.width/2 - 47, buttonTop, self.frame.size.width - 52, 30);
	//greenLabel.frame = CGRectMake(12, buttonTop, self.frame.size.width - 52, 30);
	//greenSlider.frame = CGRectMake(greenLabel.frame.origin.x + 65, greenLabel.frame.origin.y, greenLabel.frame.size.width - 65, greenLabel.frame.size.height);
	
	buttonTop -= 40;
	redSlider.frame = CGRectMake(46, buttonTop, self.frame.size.width - 52 - 65, 30);
	buttonTop -= 22;
	redLabel.frame = CGRectMake(self.frame.size.width/2 - 38, buttonTop, self.frame.size.width - 52, 30);
}


@end