//
//  FirstViewController.m
//  Electachord
//
//  Created by Nick Kruge on 3/2/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "FirstViewController.h"
#import "mo_accel.h"
#import "mo_audio.h"
#import "mo_net.h"

#import <math.h>
#import "ASIFormDataRequest.h"
#import "mo_location.h"

const NSString * server = @"http://192.168.180.47:8888/";
const NSString * myLocalIP;

void locationCallback( CLLocation * newLocation, CLLocation * oldLocation, void * data);
ASIFormDataRequest * setupPostVars(ASIFormDataRequest *request, objc_object* myChordroot, objc_object* myChordqual, NSString*myHandle);
ASIFormDataRequest * setupVoteVars(ASIFormDataRequest *request, NSString* myRequest, NSString * myHandle, NSString*myChord);
ASIFormDataRequest * setupIP(ASIFormDataRequest *request, NSString* myRequest);

@implementation FirstViewController
@synthesize runForSoloist;
@synthesize changeChordVote;
@synthesize timer;
@synthesize timer2;
@synthesize voteTimer;
@synthesize tf;
//@synthesize username;

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	// Get the location
	// really this is so it will ask the user now as oppsed to later if its okay.
	MoLocation::getLocation();
	
	[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector 
	 (handleChordChange:) name:@"changeChord" object:nil];
	
	[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector 
	 (dismissWindow:) name:@"dismissWindow" object:nil];
	
	tempstring = new char[25];
	username = new char[25];
	currentChord = new char[25];
	
	addAlert = [[[UIAlertView alloc] initWithTitle:@"Welcome!" 
										   message:@"Enter your user name!" 
										  delegate:self 
								 cancelButtonTitle:@"No, Thanks" 
								 otherButtonTitles:@"Submit", nil] autorelease];
	[addAlert addTextFieldWithValue:@"" label:@"Name"];
	tf = [addAlert textFieldAtIndex:0];
	tf.clearButtonMode = UITextFieldViewModeWhileEditing;
	tf.keyboardType = UIKeyboardTypeAlphabet;
	tf.keyboardAppearance = UIKeyboardAppearanceAlert;
	[addAlert setTag:15];
	[addAlert show];
	
	myLocalIP = [self getAddress];
	NSLog(@"IP Address: %@", myLocalIP);
	NSURL *url = [NSURL URLWithString:[server stringByAppendingString:@"tutorial/saveIP.php"]];
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:url];
	
	// Setup the variables for the request
	//NSLog(@"%s",username);
	//NSLog(@"Received chord name: %s", currentChord);
	request = setupIP(request, myLocalIP);
	
	[request startAsynchronous];
}

- (void) dismissWindow:(NSNotification *) notification {
	NSLog(@"dismissing open windows");
	if ([changeChord isVisible]) [changeChord dismissWithClickedButtonIndex:10 animated:YES];
	if ([theChangeChordVote isVisible]) [theChangeChordVote dismissWithClickedButtonIndex:10 animated:YES];
	if ([wantToSolo isVisible]) [wantToSolo dismissWithClickedButtonIndex:10 animated:YES];
	if ([voteResult isVisible]) [voteResult dismissWithClickedButtonIndex:0 animated:YES];
}

-(NSString*)getAddress {
	char iphone_ip[255];
	strcpy(iphone_ip,"127.0.0.1"); // if everything fails
	NSHost* myhost =[NSHost currentHost];
	if (myhost)
	{
		NSString *ad = [myhost address];
		if (ad)
			strcpy(iphone_ip,[ad cStringUsingEncoding: NSISOLatin1StringEncoding]);
	}
	return [NSString stringWithFormat:@"%s",iphone_ip]; 
}

- (void) handleChordChange: (NSNotification *) notification
{ 
	UISlider * ChordQual = [[notification userInfo] objectForKey:@"key1"];
	UISlider * ChordRoot = [[notification userInfo] objectForKey:@"key2"];
	chordName = [[notification userInfo] objectForKey:@"key5"];
	
	if (chordName != NULL) {
		tempstring = [chordName UTF8String];
		for (int i = 0; i < 25; i++) {
			currentChord[i] = tempstring[i];
		}
	}
	
	chordRoot = floor(ChordRoot.value * 12);
	qualnumber = floor(ChordQual.value * 7);
}

-(IBAction) hitChangeChordVote {
	
	 
	timer = [NSTimer scheduledTimerWithTimeInterval:15.0 target:self selector:@selector(killChangeChord:) userInfo:nil repeats:NO];
	NSLog(@"changing chord");
	changeChord = [[ChordChangeAlertView alloc] initWithTitle:@"Change Chord"
													  message:nil 
													 delegate:self 
											cancelButtonTitle:@"Cancel" 
											otherButtonTitles:@"Submit", nil];
	[changeChord setTag:14];
	[changeChord show];
}

-(void)killChangeChord:(NSTimer *)theTimer{
	if ([changeChord isVisible]) [changeChord dismissWithClickedButtonIndex:10 animated:YES];
}

-(IBAction) hitRunForSoloist {
	
	timer = [NSTimer scheduledTimerWithTimeInterval:4.0 target:self selector:@selector(killRunForSoloist:) userInfo:nil repeats:NO];
	
	wantToSolo = [[UIAlertView alloc] initWithTitle:@"Solo Time!" 
										message:@"Do you really want to run for soloist?" 
									   delegate:self 
							  cancelButtonTitle:@"Maybe not..." 
							  otherButtonTitles:@"Let's Rock!", nil];
	[wantToSolo setTag:13];
	[wantToSolo show];
	NSLog(@"run for soloist");

}	

-(void)killRunForSoloist:(NSTimer *)theTimer{
	if ([wantToSolo isVisible]) [wantToSolo dismissWithClickedButtonIndex:10 animated:YES];
}



- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex {
	if ([alertView tag] == 13) {    // it's the soloist alert
        if (buttonIndex == 0) {     // and they clicked cancel.
            if ([timer isValid]) [timer invalidate];
			NSLog(@"run for soloist cancelled");
        }
		if (buttonIndex == 1) {     // and they clicked okay.
            if ([timer isValid]) [timer invalidate];
			NSLog(@"running for soloist");
			
			NSURL *url2 = [NSURL URLWithString:[server stringByAppendingString:@"tutorial/saveMessage.php"]];
			ASIFormDataRequest *request2 = [ASIFormDataRequest requestWithURL:url2];
			
			// Setup the variables for the request
			request2 = setupVoteVars(request2, [NSString stringWithFormat:@"RunForSoloist"], [NSString stringWithFormat:@"%s",username], [NSString stringWithFormat: @"%s", currentChord]);
			
			[request2 startAsynchronous];
			NSError *error = [request2 error];
			if (!error) {
				NSString *response = [request2 responseString];
				NSLog(@"%@", response);
			}
			
			voteTimer = [NSTimer scheduledTimerWithTimeInterval:5.0 target:self selector:@selector(getSoloistVoteResults:) userInfo:nil repeats:NO];
        }
    }
	
	if ([alertView tag] == 14) {    // its the chordview alert
		if (buttonIndex == 0) {     // and they clicked cancel.
            if ([timer isValid]) [timer invalidate];
			NSLog(@"cancel chord");
        }
		if (buttonIndex == 1) {     // and they set the new chord.
           if ([timer isValid]) [timer invalidate];
			
			
			
			NSURL *url = [NSURL URLWithString:[server stringByAppendingString:@"tutorial/saveEvent.php"]];
			ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:url];
			
			// Setup the variables for the request
			//NSLog(@"%s",username);
			//NSLog(@"Received chord name: %s", currentChord);
			request = setupPostVars(request, [NSString stringWithFormat:@"%d",chordRoot], [NSString stringWithFormat:@"%d",qualnumber], [NSString stringWithFormat:@"%s",username]);
			
			[request startAsynchronous];
			
			
			NSURL *url2 = [NSURL URLWithString:[server stringByAppendingString:@"tutorial/saveMessage.php"]];
			ASIFormDataRequest *request2 = [ASIFormDataRequest requestWithURL:url2];
			
			// Setup the variables for the request
			request2 = setupVoteVars(request2, [NSString stringWithFormat:@"ChangeChord"], [NSString stringWithFormat:@"%s",username], [NSString stringWithFormat: @"%s", currentChord]);
			
			[request2 startAsynchronous];
			NSError *error = [request2 error];
			if (!error) {
				NSString *response = [request2 responseString];
				NSLog(@"%@", response);
			}
			
			voteTimer = [NSTimer scheduledTimerWithTimeInterval:5.0 target:self selector:@selector(getChordVoteResults:) userInfo:nil repeats:NO];
			
        }
	}
	
	if ([alertView tag] == 15) {
		if (buttonIndex == 1) {
			tempstring = [tf.text UTF8String];
			for (int i = 0; i < 25; i++) {
				username[i] = tempstring[i];
			}
			if ([tf.text isEqualToString: @""]) username = "default username";
		}
	}
}

- (void)getChordVoteResults: (NSTimer *)theTimer{
	NSURL * URL = [[NSURL alloc] initWithString:[server stringByAppendingString:@"tutorial/getVote.php"]];
	
	// Form the request
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:URL];
	[request setPostValue:@"1" forKey:@"num_requests"]; 
	
	// Start sending synchronously
	[request startSynchronous];
	
	// Display any error messages
	NSError *error = [request error];
	if (!error) {
		NSString *response = [request responseString];
		NSLog(response);
	}
	
	// Parse the raw response using XML
	NSXMLParser * xmlParser = [[NSXMLParser alloc] initWithData:[request rawResponseData]];
	[xmlParser setDelegate:self];
	[xmlParser setShouldProcessNamespaces:NO]; // We don't care about namespaces
	[xmlParser setShouldReportNamespacePrefixes:NO]; //
	[xmlParser setShouldResolveExternalEntities:NO]; // We just want data, no other stuff
	
	[xmlParser parse];  // start parsing (event driven)
	
	[xmlParser release];
	[URL release];
	
	NSLog(@"vote:\t%@\ncount:\t%@\n", vote, votecount, votecountloser);
	if ([vote isEqualToString:@"yea"]) {
		NSURL *url2 = [NSURL URLWithString:[server stringByAppendingString:@"tutorial/saveMessage.php"]];
		ASIFormDataRequest *request2 = [ASIFormDataRequest requestWithURL:url2];
		NSLog(@"here");
		// Setup the variables for the request
		request2 = setupVoteVars(request2, [NSString stringWithFormat:@"YesCommitChord"], [NSString stringWithFormat:@"%s",username], 
								 [NSString stringWithFormat: @"to %s by a vote of %@ to %@", currentChord, votecount, votecountloser]);
		NSLog(@"here");
		[request2 startAsynchronous];
		NSError *error = [request2 error];
		if (!error) {
			NSString *response = [request2 responseString];
			NSLog(@"%@", response);
		}
		
	}
		
	else {
		NSURL *url2 = [NSURL URLWithString:[server stringByAppendingString:@"tutorial/saveMessage.php"]];
		ASIFormDataRequest *request2 = [ASIFormDataRequest requestWithURL:url2];
		
		// Setup the variables for the request
		request2 = setupVoteVars(request2, [NSString stringWithFormat:@"DontCommitChord"], [NSString stringWithFormat:@"%s",username], 
								 [NSString stringWithFormat: @"to %s by a vote of %@ to %@", currentChord, votecount, votecountloser]);
		
		[request2 startAsynchronous];
		NSError *error = [request2 error];
		if (!error) {
			NSString *response = [request2 responseString];
			NSLog(@"%@", response);
		}
	}
}

- (void)getSoloistVoteResults: (NSTimer *)theTimer{
	NSURL * URL = [[NSURL alloc] initWithString:[server stringByAppendingString:@"tutorial/getVote.php"]];
	
	// Form the request
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:URL];
	[request setPostValue:@"1" forKey:@"num_requests"]; 
	
	// Start sending synchronously
	[request startSynchronous];
	
	// Display any error messages
	NSError *error = [request error];
	if (!error) {
		NSString *response = [request responseString];
		NSLog(response);
	}
	
	// Parse the raw response using XML
	NSXMLParser * xmlParser = [[NSXMLParser alloc] initWithData:[request rawResponseData]];
	[xmlParser setDelegate:self];
	[xmlParser setShouldProcessNamespaces:NO]; // We don't care about namespaces
	[xmlParser setShouldReportNamespacePrefixes:NO]; //
	[xmlParser setShouldResolveExternalEntities:NO]; // We just want data, no other stuff
	
	[xmlParser parse];  // start parsing (event driven)
	
	[xmlParser release];
	[URL release];
	
	NSLog(@"vote:\t%@\ncount:\t%@\n", vote, votecount);
	if ([vote isEqualToString:@"yea"]) {
		NSURL *url2 = [NSURL URLWithString:[server stringByAppendingString:@"tutorial/saveMessage.php"]];
		ASIFormDataRequest *request2 = [ASIFormDataRequest requestWithURL:url2];
		
		// Setup the variables for the request
		request2 = setupVoteVars(request2, [NSString stringWithFormat:@"YesSoloist"], [NSString stringWithFormat:@"%s",username], 
								 [NSString stringWithFormat: @"by a vote of %@ to %@", votecount, votecountloser]);
		
		[request2 startAsynchronous];
		NSError *error = [request2 error];
		if (!error) {
			NSString *response = [request2 responseString];
			NSLog(@"%@", response);
		}
		
	}
	
	else {
		NSURL *url2 = [NSURL URLWithString:[server stringByAppendingString:@"tutorial/saveMessage.php"]];
		ASIFormDataRequest *request2 = [ASIFormDataRequest requestWithURL:url2];
		
		// Setup the variables for the request
		request2 = setupVoteVars(request2, [NSString stringWithFormat:@"NoSoloist"], [NSString stringWithFormat:@"%s",username], 
								 [NSString stringWithFormat: @"by a vote of %@ to %@", votecount, votecountloser]);
		
		[request2 startAsynchronous];
		NSError *error = [request2 error];
		if (!error) {
			NSString *response = [request2 responseString];
			NSLog(@"%@", response);
		}
	}
}

-(void)killVoteResult:(NSTimer *)theTimer{
	if ([voteResult isVisible]) [voteResult dismissWithClickedButtonIndex:10 animated:YES];
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}



- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}



ASIFormDataRequest * setupPostVars(ASIFormDataRequest *request, objc_object* myChordroot, objc_object* myChordqual, NSString * myHandle)
{
	CLLocation * loc = MoLocation::getLocation();
	CLLocationCoordinate2D  coord = [loc coordinate];
	double lat = coord.latitude; 
	double lon = coord.longitude;
	
	[request setPostValue:[[UIDevice currentDevice] uniqueIdentifier] forKey:@"device_id"];
	[request setPostValue:myHandle forKey:@"handle"];
	[request setPostValue:[NSString stringWithFormat:@"%f",lat] forKey:@"lat"];
	[request setPostValue:[NSString stringWithFormat:@"%f",lon] forKey:@"long"];
	[request setPostValue:myChordroot forKey:@"chord_root"];
	[request setPostValue:myChordqual forKey:@"chord_qual"];	
	
	return request;
	
}

ASIFormDataRequest * setupVoteVars(ASIFormDataRequest *request2, NSString* myRequest, NSString * myHandle, NSString*myChord)
{	
	NSLog(@"sending vote request");
	CLLocation * loc = MoLocation::getLocation();
	CLLocationCoordinate2D  coord = [loc coordinate];
	double lat = coord.latitude; 
	double lon = coord.longitude;
	
	[request2 setPostValue:[[UIDevice currentDevice] uniqueIdentifier] forKey:@"device_id"];
	[request2 setPostValue:myHandle forKey:@"handle"];
	[request2 setPostValue:[NSString stringWithFormat:@"%f",lat] forKey:@"lat"];
	[request2 setPostValue:[NSString stringWithFormat:@"%f",lon] forKey:@"long"];
	[request2 setPostValue:myRequest forKey:@"action"];
	[request2 setPostValue:myChord forKey:@"data"];
	
	return request2;
	
}

ASIFormDataRequest * setupIP(ASIFormDataRequest *request, NSString* myIP)
{	
	NSLog(@"sending IP");
	
	[request setPostValue:[[UIDevice currentDevice] uniqueIdentifier] forKey:@"device_id"];
	[request setPostValue:myIP forKey:@"IP"];
	
	return request;
	
}

- (void)parserDidStartDocument:(NSXMLParser *)parser {
    //NSLog(@"Start XML parsing");
    //[text setText:@""];
}

- (void)parserDidEndDocument:(NSXMLParser *)parser {
    //NSLog(@"End XML parsing");
    // in case you want to do something when the XML document parsing ends
}

- (void)parser:(NSXMLParser *)parser 
didStartElement:(NSString *)elementName 
namespaceURI:(NSString *)namespaceURI 
qualifiedName:(NSString *)qName 
attributes:(NSDictionary *)attributeDict {
    
    // not sure what this do (probably escape characters)
    if (qName) {
        elementName = qName;
    }
	
    if ([elementName isEqualToString:@"vote"]) {
        vote = [attributeDict objectForKey:@"vote"];
        votecount = [attributeDict objectForKey:@"count"];
		votecountloser = [attributeDict objectForKey:@"losecount"];
		
		//chordRoot = [event.chord_root intValue];
		//qualnumber = [event.chord_qual intValue];
		
		//NSLog(@"we received %d %d",chordRoot,qualnumber);
        
        // append this event to other events on the screen
        //NSLog(@"vote:\t%@\ncount:\t%@\n", vote, votecount);
    }
}
@end
