//
//  RotatingTabBarController.mm
//  Electachord
//
//  Created by Nick Kruge on 3/2/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "RotatingTabBarController.h"
#import "mo_audio.h"
#import "mo_accel.h"
#import "mo_touch.h"
#import "fluidsynth.h"
#import <iostream>
#import <math.h>
#import "ASIFormDataRequest.h"
#import "mo_location.h"

#define SRATE 22050
#define FRAMESIZE 512 
#define NUMCHANNELS 2

const NSString * server2 = @"http://192.168.180.47:8888/";

double g_fc_target = 440.f;
double g_fc = 440.f;
double g_fc_slew = 0.003f;
//bool goSine = true;
double g_gain = 0.5f;
double g_gain_target = 0.5f;
struct AudioData * audioData;
int currentInstrument = 0;
int chordFoundation[] = {0, 4, 7, 12, 12, 16, 19, 24, 24};
int chord[] = {0, 4, 7, 12, 12, 16, 19, 24, 24};
int minorkey[] = {0, -1, 0, 0, 0, -1, 0, 0, 0};
int maj[] = {0, 0, 0, 0, 0, 0, 0, 0, 0};
int minor7[] = {0, -1, 0, -2, 0, -1, 0, -2, 0};
int major7[] = {0, 0, 0, -1, 0, 0, 0, -1, 0};
int major9[] = {0, 0, 0, -1, 0, -2, -3, -1, 2};
int dim[] = {0, -1, -1, -3, 0, -1, -1, -3, 0};
int aug[] = {0, 0, 1, 0, 0, 0, 1, 0, 0};
float xprev, yprev, zprev;

bool voteOnChangeChord;
bool currentSoloist;

ASIFormDataRequest * submitVoteVars(ASIFormDataRequest *request3, NSString* theVote);

/*
//wrapper for fluidsynth

//-----------------------------------------------------------------------------
// name: class FluidSynth
// desc: FluidSynth class
//-----------------------------------------------------------------------------
class FluidSynth
	{
	public:
		// constructor
		FluidSynth() : m_settings(NULL), m_synth(NULL) { }
		
		// initialization
		bool init( int srate )
		{
			if( m_synth != NULL )
			{
				std::cerr << "synth already initialized..." << std::endl;
				return false;
			}
			
			// log
			NSLog( @"initializing synth..." );
			// instantiate settings
			m_settings = new_fluid_settings();
			// set sample rate
			fluid_settings_setnum( m_settings, (char *)"synth.sample-rate", (double)srate );
			// instantiate the synth
			m_synth = new_fluid_synth( m_settings );
			
			return m_synth != NULL;
		}
		
		// load a font
		bool load( const char * filename, const char * extension )
		{
			std::string path;
			NSString * tempStr = [NSString stringWithUTF8String:filename];
			NSString * tempExt = [NSString stringWithUTF8String:extension];
			path = [[[NSBundle mainBundle] pathForResource: tempStr ofType:tempExt] UTF8String];
			
			if( m_synth == NULL ) return false;
			NSLog( @"loading font file: %s.%s...", filename, extension );
			if( fluid_synth_sfload( m_synth, path.c_str(), true ) == -1 )
			{
				// error
				std::cerr << "cannot load font file: " << filename << "." << extension << std::endl;
				return false;
			}
			
			return true;
		}
		
		// program change
		void programChange( int channel, int program )
		{
			if( m_synth == NULL ) return;
			if( program < 0 || program > 127 ) return;
			fluid_synth_program_change( m_synth, channel, program );
		}
		
		// noteOn
		void noteOn( int channel, int pitch, int velocity )
		{
			if( m_synth == NULL ) return;
			fluid_synth_noteon( m_synth, channel, pitch, velocity );
		}
		
		// noteOff
		void noteOff( int channel, int pitch )
		{
			if( m_synth == NULL ) return;
			fluid_synth_noteoff( m_synth, channel, pitch );
		}
		
		// synthesize (stereo)
		void synthesize2( Float32 * buffer, UInt32 numFrames )
		{
			if( m_synth == NULL ) return;
			// get it from fluidsynth
			fluid_synth_write_float( m_synth, numFrames, buffer, 0, 2, buffer, 1, 2 );
		}
		
	public:
		fluid_settings_t * m_settings;
		fluid_synth_t * m_synth;
	};

FluidSynth g_synth;
// sounds i like: 44--good pad strings
// 46 -- harp
// 50 -- synthy pad strings
// 52 ahhhs
// 62 good synth
// 63 warm synth
// 76 flute
// 77-79 crazy synths
// 80 triangle wave lead 86, 87, 


*/
// implement audio callback here
void audioCallback( Float32 * buffer, UInt32 frameSize, void * userData)
{
	
	AudioData * data = (AudioData*)userData;
	
	for (int i = 0; i < frameSize; i++)
	{
		buffer[2*i] = buffer[2*i + 1] = 0;
		
		// moog!
		if (currentInstrument == 0) {
			g_fc = (g_fc_target - g_fc)*g_fc_slew + g_fc;
			data->moog->setFrequency(g_fc/2);
			buffer[2*i] = buffer[2*i + 1] = g_gain*(.65*data->moog->tick(1));
		}
		
		// saw!
		else if (currentInstrument == 1) {
			g_fc = (g_fc_target - g_fc)*g_fc_slew + g_fc;
			data->saw->setFrequency(g_fc);
			buffer[2*i] = buffer[2*i + 1] = g_gain*data->reverb->tick(.1*data->saw->tick());
		}
		
		// sine!
		else if (currentInstrument == 2) {
			g_fc = (g_fc_target - g_fc)*g_fc_slew + g_fc;
			data->metl->setFrequency(g_fc*2);
			buffer[2*i] = buffer[2*i + 1] = g_gain*data->reverb->tick(.25*data->metl->tick());
		}
		
		// shakers!
		else if (currentInstrument == 3) {
			buffer[2*i] = buffer[2*i + 1] = 1.0 * (data->shaker->tick());
		}
	}
	
	/*
	static int count = 0;
    static int prog = 23;
    static int pitch = 36;
    
    count += frameSize;
    if( count >= SRATE / 8 )
    {
        NSLog( @"." );
        g_synth.noteOff( 0, pitch );
        if( ++pitch > 65 ) {
			pitch = 45;
			prog++;
			NSLog(@"%d",prog);
		}
        g_synth.noteOn( 0, pitch, 120 );
        g_synth.programChange( 0, prog );
        // if( ++prog > 5 ) prog = 0;
        count = 0;
    }
	
    // get output from synth
    g_synth.synthesize2( buffer, frameSize );
	 */
}

void setPitch(int pitchOffset) {
	g_fc_target = 110.0*pow(2,pitchOffset/12.0);
}

//implement Accel
void accelCallback( double x, double y, double z, void * data )
{	
	if (currentInstrument == 3 && (abs(x-xprev)+abs(y-yprev)) > .1) 
		audioData->shaker->controlChange( 2, (abs(x-xprev)+abs(y-yprev))*30.0 );
	double temp = abs(x);
	if (temp > 1.0) temp = 1.0;
	g_gain_target = (1.0 - temp);
	g_gain = (g_gain_target - g_gain)*0.2 + g_gain;
	
	if (y < -1) y = -1;
	if (y > 1.5) y = 1.5;
	int pitchIndex = floor(((y+1) * 10)/3);
	setPitch(chord[pitchIndex]);
	
	xprev = x;
	yprev = y;
	//zprev = z;
}

@implementation RotatingTabBarController
@synthesize myTabBar;
@synthesize myView;
@synthesize timer;
@synthesize timer2;

- (void)tabBar:(UITabBar *)tabBar didSelectItem:(UITabBarItem *)item
{
	NSLog(@"this tag is: %d", [item tag]);
	currentInstrument = [item tag];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	return (interfaceOrientation == UIInterfaceOrientationLandscapeLeft);// || 
			//interfaceOrientation == UIInterfaceOrientationLandscapeRight);
}



- (void)viewDidLoad {
    [super viewDidLoad];
	
	audioData = new AudioData;
	audioData->moog = new Moog();
	audioData->moog->noteOn(55.0, 1.0);
	audioData->moog->controlChange(2,.5);
	audioData->saw = new BlitSaw();
	audioData->metl = new HevyMetl();
	audioData->metl->noteOn(220.0, 1.0);
	audioData->reverb = new NRev();
	audioData->shaker = new Shakers();
	audioData->shaker->controlChange( 11, 30 );
	audioData->shaker->noteOn( 1.0, 1.0 );
	audioData->shaker->controlChange( 1071, 2.0 );
	audioData->shaker->setSampleRate(SRATE);
	 /*
	NSLog(@"here");
	// synth
    g_synth.init( SRATE );
    // load
    g_synth.load( "gugs", "sf2" );
	NSLog(@"here2");*/
	
	// Init Audio
	NSLog(@"Initializing Audio");

	// Init the Audio Layer
	bool result = MoAudio::init( SRATE, FRAMESIZE, NUMCHANNELS);

	if(!result)
	{
		NSLog(@"Cannot initialize real-time audio!");
		
		return;
	}

	// start the audio layer
	result = MoAudio::start( audioCallback, audioData);

	if(!result)
	{
		NSLog(@"Cannot start real-time audio!");
		
		return;
	}
	
	// Init Accel
	NSLog(@"Initializing Accelerometer");
	MoAccel::addCallback( accelCallback, NULL);
	
	[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector 
	 (commitChordChange:) name:@"changeChordCommit" object:nil];
	
	timer = [NSTimer scheduledTimerWithTimeInterval: 0.3
											 target: self
										   selector: @selector(handleTimer:)
										   userInfo: nil
											repeats: YES];
	
	voteOnChangeChord = true;
	currentSoloist = false;
    
}

- (void) handleTimer: (NSTimer *) timer
{
	//NSLog(@"messages callback");
	
	NSURL * URL = [[NSURL alloc] initWithString:[server2 stringByAppendingString:@"tutorial/getMessage.php"]];
	
	// Form the request
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:URL];
	[request setPostValue:@"1" forKey:@"num_requests"]; 
	[request setDelegate:self];
	
	// Start sending Asynchronously
	[request startAsynchronous];
	
	// Display any error messages
	//NSError *error = [request error];
	//if (!error) {
		//NSString *response = [request responseString];
		//NSLog(response);
	//}
} 

- (void)requestFinished:(ASIHTTPRequest *)request
{
	// Use when fetching text data
	//NSString *responseString = [request responseString];
	
	// Parse the raw response using XML
	NSXMLParser * xmlParser = [[NSXMLParser alloc] initWithData:[request rawResponseData]];
	[xmlParser setDelegate:self];
	[xmlParser setShouldProcessNamespaces:NO]; // We don't care about namespaces
	[xmlParser setShouldReportNamespacePrefixes:NO]; //
	[xmlParser setShouldResolveExternalEntities:NO]; // We just want data, no other stuff
	
	[xmlParser parse];  // start parsing (event driven)
	
	[xmlParser release];
}

- (void)requestFailed:(ASIHTTPRequest *)request
{
	NSLog(@"request failed");
	//NSError *error = [request error];
	[request cancel];
}


- (void) commitChordChange: (NSNotification *) notification
{ 
	NSString * activate = [[notification userInfo] objectForKey:@"key3"];
	
	
	if (activate == @"1") {
		NSLog(@"Getting XML data");
		
		NSURL * URL = [[NSURL alloc] initWithString:[server2 stringByAppendingString:@"tutorial/getEvents.php"]];
		
		// Form the request
		ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:URL];
		[request setPostValue:@"1" forKey:@"num_requests"]; 
		[request setDelegate:self];
		[request startAsynchronous];
		
		// Parse the raw response using XML
		NSXMLParser * xmlParser = [[NSXMLParser alloc] initWithData:[request rawResponseData]];
		[xmlParser setDelegate:self];
		[xmlParser setShouldProcessNamespaces:NO]; // We don't care about namespaces
		[xmlParser setShouldReportNamespacePrefixes:NO]; //
		[xmlParser setShouldResolveExternalEntities:NO]; // We just want data, no other stuff
		
		[xmlParser parse];  // start parsing (event driven)
		
		[xmlParser release];
		[URL release];
		
		for (int i = 0; i < 9; i++) {
			chord[i] = chordFoundation[i] + chordRoot;
			switch(qualnumber) {
				case 0:
				case 1: chord[i] += dim[i];
					break;
				case 2: chord[i] += minorkey[i];
					break;
				case 3: chord[i] += minor7[i];;
					break;
				case 4: chord[i] += maj[i];;
					break;
				case 5: chord[i] += major7[i];;
					break;
				case 6: chord[i] += major9[i];
					break;
				case 7: chord[i] += aug[i];;
					break;
			}
		}
	}
}

/////////////////////////////////////////////////////////
- (void)parserDidStartDocument:(NSXMLParser *)parser {
    //NSLog(@"Start XML parsing");
    //[text setText:@""];
}

- (void)parserDidEndDocument:(NSXMLParser *)parser {
    //NSLog(@"End XML parsing");
    // in case you want to do something when the XML document parsing ends
}

- (void)parser:(NSXMLParser *)parser 
didStartElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI 
 qualifiedName:(NSString *)qName 
	attributes:(NSDictionary *)attributeDict {
    
    // not sure what this do (probably escape characters)
    if (qName) {
        elementName = qName;
    }
	
    if ([elementName isEqualToString:@"event"]) {
        event.id = [attributeDict objectForKey:@"id"];
        event.latitude = [attributeDict objectForKey:@"latitude"];
        event.longitude = [attributeDict objectForKey:@"longitude"];
        event.chord_root = [attributeDict objectForKey:@"chord_root"];
        event.chord_qual = [attributeDict objectForKey:@"chord_qual"];
		
		chordRoot = [event.chord_root intValue];
		qualnumber = [event.chord_qual intValue];
		
		NSLog(@"we received %d %d",chordRoot,qualnumber);
        
        // append this event to other events on the screen
        NSLog(@"%@id:\t%@\nlatitude:\t%@\nlongitude:\t%@\nchord root:\t%@\nchord quality:\t%@\n", [text text], event.id, event.latitude, event.longitude, event.chord_root, event.chord_qual);
    }
	
	if ([elementName isEqualToString:@"message"]) {
        myMessage.id = [attributeDict objectForKey:@"id"];
        myMessage.message = [attributeDict objectForKey:@"action"];
        myMessage.handle = [attributeDict objectForKey:@"handle"];
		myMessage.data = [attributeDict objectForKey:@"data"];
        
        // append this event to other events on the screen
		if ([myMessage.message isEqualToString:@"ChangeChord"] && voteOnChangeChord) {
			timer = [NSTimer scheduledTimerWithTimeInterval:5.0 target:self selector:@selector(killChangeChord:) userInfo:nil repeats:NO];
			voteOnChangeChord = false;
			NSDictionary * dict = [NSDictionary dictionaryWithObjectsAndKeys: 
								   @"1", @"key6", nil]; 
			[[NSNotificationCenter defaultCenter] postNotificationName:@"dismissWindow" object:self userInfo: dict];
			NSString * userMessage = [NSString stringWithFormat:@"%@ has motioned to change the chord to %@. How will you vote?",myMessage.handle, myMessage.data];
			NSString * thisTitle = [NSString stringWithFormat:@"Change Chord to %@?", myMessage.data];
			NSLog(@"id:\t%@\nmessage\t%@\nhandle:\t%@\n", myMessage.id, myMessage.message, myMessage.handle);
			theChangeChordVote = [[[UIAlertView alloc] initWithTitle:thisTitle 
														message:userMessage 
														delegate:self cancelButtonTitle:@"Nay!" 
											   otherButtonTitles:@"Yea!", nil] autorelease];
		
			[theChangeChordVote setTag:12];
			[theChangeChordVote show];
		}
		if ([myMessage.message isEqualToString:@"RunForSoloist"] && voteOnChangeChord && !currentSoloist) {
			NSLog(@"Soloist vote");
			timer = [NSTimer scheduledTimerWithTimeInterval:5.0 target:self selector:@selector(killChangeChord:) userInfo:nil repeats:NO];
			voteOnChangeChord = false;
			NSDictionary * dict = [NSDictionary dictionaryWithObjectsAndKeys: 
								   @"1", @"key6", nil]; 
			[[NSNotificationCenter defaultCenter] postNotificationName:@"dismissWindow" object:self userInfo: dict];
			NSString * userMessage = [NSString stringWithFormat:@"%@ has run for soloist! How will you vote?",myMessage.handle];
			NSString * thisTitle = [NSString stringWithFormat:@"%@ for soloist?", myMessage.handle];
			theChangeChordVote = [[[UIAlertView alloc] initWithTitle:thisTitle 
															 message:userMessage 
															delegate:self cancelButtonTitle:@"Nay!" 
												   otherButtonTitles:@"Yea!", nil] autorelease];
			
			[theChangeChordVote setTag:12];
			[theChangeChordVote show];
		}
		//-------------------------<<<<<<<<<<<<<<<<<
		if ([myMessage.message isEqualToString:@"YesCommitChord"] && voteOnChangeChord) {
			voteOnChangeChord = false;
			NSDictionary * dict = [NSDictionary dictionaryWithObjectsAndKeys: 
								   @"1", @"key3", nil]; 
			[[NSNotificationCenter defaultCenter] postNotificationName:@"changeChordCommit" object:self userInfo: dict];
			NSDictionary * dict2 = [NSDictionary dictionaryWithObjectsAndKeys: 
								   @"1", @"key6", nil]; 
			[[NSNotificationCenter defaultCenter] postNotificationName:@"dismissWindow" object:self userInfo: dict2];
			NSString * userMessage = [NSString stringWithFormat:@"Passed %@'s motion to change the chord %@.",myMessage.handle, myMessage.data];
			timer2 = [NSTimer scheduledTimerWithTimeInterval:4.0 target:self selector:@selector(killVoteResult:) userInfo:nil repeats:NO];
			voteResult = [[[UIAlertView alloc] initWithTitle:@"New Chord Elected!" 
													 message:userMessage
													delegate:self cancelButtonTitle:@"Okay" 
										   otherButtonTitles:nil] autorelease];
			[voteResult show];
			[voteResult setTag:9];
		}
		if ([myMessage.message isEqualToString:@"DontCommitChord"] && voteOnChangeChord) {
			voteOnChangeChord = false;
			NSDictionary * dict = [NSDictionary dictionaryWithObjectsAndKeys: 
								   @"1", @"key6", nil]; 
			[[NSNotificationCenter defaultCenter] postNotificationName:@"dismissWindow" object:self userInfo: dict];
			NSString * userMessage = [NSString stringWithFormat:@"Denied %@'s motion to change the chord %@.",myMessage.handle, myMessage.data];
			timer2 = [NSTimer scheduledTimerWithTimeInterval:4.0 target:self selector:@selector(killVoteResult:) userInfo:nil repeats:NO];
			voteResult = [[[UIAlertView alloc] initWithTitle:@"New Chord Denied" 
													 message:userMessage 
													delegate:self cancelButtonTitle:@"Okay" 
										   otherButtonTitles:nil] autorelease];
			[voteResult show];
			[voteResult setTag:9];
		}
		//-------------------------<<<<<<<<<<<<<<<<<
		if ([myMessage.message isEqualToString:@"YesSoloist"] && voteOnChangeChord) {
			voteOnChangeChord = false;
			NSDictionary * dict = [NSDictionary dictionaryWithObjectsAndKeys: 
								   @"1", @"key6", nil]; 
			[[NSNotificationCenter defaultCenter] postNotificationName:@"dismissWindow" object:self userInfo: dict];
			NSString * userMessage = [NSString stringWithFormat:@"%@'s motion to solo was accepted %@.\n Bring it on!",myMessage.handle, myMessage.data];
			timer2 = [NSTimer scheduledTimerWithTimeInterval:4.0 target:self selector:@selector(killVoteResult:) userInfo:nil repeats:NO];
			voteResult = [[[UIAlertView alloc] initWithTitle:@"New Soloist Elected!" 
													 message:userMessage
													delegate:self cancelButtonTitle:@"Okay" 
										   otherButtonTitles:nil] autorelease];
			[voteResult show];
			[voteResult setTag:9];
		}
		if ([myMessage.message isEqualToString:@"NoSoloist"] && voteOnChangeChord) {
			voteOnChangeChord = false;
			NSDictionary * dict = [NSDictionary dictionaryWithObjectsAndKeys: 
								   @"1", @"key6", nil]; 
			[[NSNotificationCenter defaultCenter] postNotificationName:@"dismissWindow" object:self userInfo: dict];
			NSString * userMessage = [NSString stringWithFormat:@"%@'s motion to solo was denied %@.",myMessage.handle, myMessage.data];
			timer2 = [NSTimer scheduledTimerWithTimeInterval:4.0 target:self selector:@selector(killVoteResult:) userInfo:nil repeats:NO];
			voteResult = [[[UIAlertView alloc] initWithTitle:@"New Soloist Denied" 
													 message:userMessage 
													delegate:self cancelButtonTitle:@"Okay" 
										   otherButtonTitles:nil] autorelease];
			[voteResult show];
			[voteResult setTag:9];
		}
    }
}

-(void)killChangeChord:(NSTimer *)theTimer{
	if ([theChangeChordVote isVisible]) [theChangeChordVote dismissWithClickedButtonIndex:10 animated:YES];
}

-(void)killVoteResult:(NSTimer *)theTimer{
	if ([voteResult isVisible]) [voteResult dismissWithClickedButtonIndex:10 animated:YES];
}

- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex {
    if ([alertView tag] == 12) {    // it's the change chord alert
        if (buttonIndex == 0) {     // and they clicked cancel.
            if([timer isValid]) [timer invalidate];
			voteOnChangeChord = true;
			NSLog(@"change chord: nay!");
			NSURL *url = [NSURL URLWithString:[server2 stringByAppendingString:@"tutorial/saveVote.php"]];
			ASIFormDataRequest *request3 = [ASIFormDataRequest requestWithURL:url];
			
			// Setup the variables for the request
			request3 = submitVoteVars(request3, @"nay");
			
			[request3 startAsynchronous];
			NSError *error = [request3 error];
			if (!error) {
				NSString *response = [request3 responseString];
				NSLog(@"%@", response);
			}
        }
		if (buttonIndex == 1) {     // and they clicked okay.
			if([timer isValid]) [timer invalidate];
			voteOnChangeChord = true;
			NSLog(@"change chord: yea!");
			NSURL *url = [NSURL URLWithString:[server2 stringByAppendingString:@"tutorial/saveVote.php"]];
			ASIFormDataRequest *request3 = [ASIFormDataRequest requestWithURL:url];
			
			// Setup the variables for the request
			request3 = submitVoteVars(request3, @"yea");
			
			[request3 startAsynchronous];
			NSError *error = [request3 error];
			if (!error) {
				NSString *response = [request3 responseString];
				NSLog(@"%@", response);
			}
        }
		if (buttonIndex == 10) {     // and they clicked okay.
			voteOnChangeChord = true;
			NSLog(@"user timed out!");
        }
    }
	if ([alertView tag] == 9) {
		if (buttonIndex == 0) {
			voteOnChangeChord = true;
            if([timer2 isValid]) [timer2 invalidate];
		}
		if (buttonIndex == 10)
			voteOnChangeChord = true;
	}
}

ASIFormDataRequest * submitVoteVars(ASIFormDataRequest *request3, NSString* theVote)
{	
	NSLog(@"sending vote request");
	CLLocation * loc = MoLocation::getLocation();
	CLLocationCoordinate2D  coord = [loc coordinate];
	double lat = coord.latitude; 
	double lon = coord.longitude;
	
	[request3 setPostValue:[[UIDevice currentDevice] uniqueIdentifier] forKey:@"device_id"];
	[request3 setPostValue:[NSString stringWithFormat:@"%f",lat] forKey:@"lat"];
	[request3 setPostValue:[NSString stringWithFormat:@"%f",lon] forKey:@"long"];
	[request3 setPostValue:theVote forKey:@"answer"];
	
	return request3;
	
}

- (void)parser:(NSXMLParser *)parser 
 didEndElement:(NSString *)elementName 
  namespaceURI:(NSString *)namespaceURI 
 qualifiedName:(NSString *)qName {
    
    // Do something here
    if (qName) {
        elementName = qName;
    }
}
//////////////////////////////////// End NSXMLParserDelegate Protocol Methods ///////////////////////////////////////////////



@end

